# $Date: 1996/07/02 17:19:09 $ $Author: kraume $ $Revision: 1.7 $ #

# kg, 27/12/94 #

#++
setuserinfo -- set information level for procedure

setuserinfo(p [,lev])

p   - procedure, name of procedure, domain or 'Any'
lev - level of information (positive integer)

Sets the information level of the procedure or domain p to lev. If lev
is missing the level for p is set to 0.

If p is 'Any' then the global information level is set to lev
or to 0 resp.

See 'userinfo'.
++#

setuserinfo:= proc(pnam,lev,opt)
  option hold;
begin
    if testargs() then
    	if args(0) > 3 or args(0) < 1 then error("wrong no of args") end_if;
    	if args(0) >= 2 then
    	    if domtype(level(lev,2)) <> DOM_INT then 
               error("illegal level")
            end_if;
    	    if level(lev,2) < 0 then error("illegal level") end_if;
    	end_if;
        if args(0) = 3 and not( opt=hold(Proc) ) then
           error("illegal option");
        end_if;
    end_if;
    
   
    # get proc name if argument is proc #
    if domtype(pnam) = DOM_PROC then
    	pnam:= op(pnam, 6)
    end_if;
  
    # store level for proc #
    if args(0) = 1
      then sysassign(stdlib::userinfo_level[pnam],NIL); sysassign(stdlib::userinfo_level[pnam, 1],NIL);
           if nops(stdlib::userinfo_level)=0 then sysassign(stdlib::userinfo_level,NIL); end_if;
      else sysassign(stdlib::userinfo_level[pnam],level(lev,2)); 
           if opt=hold(Proc)
             then sysassign(stdlib::userinfo_level[pnam, 1],TRUE);
             else sysassign(stdlib::userinfo_level[pnam, 1],FALSE);
           end_if;
    end_if;

    null();
end_proc:

# end of file #
