/******************************************************************************/
/* DATEI:       MKT_func.h                                                    */
/* AUTOR:       Andreas Sorgatz                                               */
/* ERSTELLT:    18/07/95                                                      */
/* GEAENDERT:   08/12/96                                                      */
/* INHALT:      Toolbox - definiert eine Makrosprache zur Kernprogrammierung  */
/*                                                                            */
/* In dieser Datei muessen alle MuPAD Header-files (*.h) eingebunden werden.  */
/* Entgegen der Konvention tragen die Objekte dieses Moduls den Praefix 'MF'  */
/* anstatt 'MKT_'.    Sie stellen die Basis einer vereinfachten Programmier-  */
/* sprache zur Implementation von System- und Modulfunktionen dar. Variablen  */
/* tragen den Praefix 'MV', Konstanten (z.B zur Steuerung von MF-Funktionen)  */
/* tragen den Praefix 'MC'                                                    */
/******************************************************************************/

/*** V O R S I C H T -- Diese Funktionen duerfen nicht in Quelldateien ein- ***/
/*** gesetzt werden, die zu 'VCAM' gelinkt werden muessen. Andernfalls muss ***/
/*** durch einen Schneeball-Effekt der gesamte Kern gelinkt werden.         ***/

#ifndef __MKT_func__
#define __MKT_func__

#ifndef MEXDSTANDARD
#  define MEXDSTANDARD                     /*** Aktivieren von MEX_extern.h ***/
#endif
#ifndef MEXDSYSTEM
#  define MEXDSYSTEM   
#endif

#ifdef DOS_FILENAMES
#  include "MMMstora.h"
#  include "MUP_typ.h"
#  include "MUP_cons.h"
#  include "MEV_eval.h"
#  include "MST_stac.h"
#  include "MUT_util.h"
#  include "MSG_sign.h"
#  include "MCM_comp.h"
#  include "MPA_pars.h"
#  include "MPA_help.h"
#  include "MSC_scan.h"
#  include "MTR_tree.h"
#  include "MIO_io.h"
#  include "MIO_loca.h"
#  include "MSU_eval.h"
#  include "MAM_ass_.h"
#  include "MAR_arra.h"
#  include "MGS_simp.h"
#  include "MTA_tabl.h"
#  include "MSR_stri.h"
#  include "MSE_set.h"
#  include "MGR_cons.h"
#  include "MGR_type.h"
#  include "MGR_makr.h"
#  include "MGR_glob.h"
#  include "MGR_exte.h"
#  include "MGR_colo.h"
#  include "MGR_file.h"
#  include "MGR_defa.h"
#  include "MGR_opti.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_chec.h"
#  include "MGR_comm.h"
#  include "MGR_init.h"
#  include "MGR_sys_.h"
#  include "MDF_diff.h"
#  include "MXP_expa.h"
#  include "MFO_open.h"
#  include "MFO_file.h"
#  include "MSY_sys_.h"
#  include "MSY_sysh.h"
#  include "MPL_para.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPH_prob.h"
#  include "MPO_poly.h"
#  include "MPO_polh.h"
#  include "MUP_func.h"
#  include "MDB_debu.h"
#  include "MHI_hist.h"
#  include "MGH_mess.h"
#  include "MPR_prot.h"
#  include "MDM_kern.h"
#  include "MNS_name.h"
#  include "MPM_matc.h"
#  include "MUP_ext.h"
#  include "MUT_debu.h"
#  include "MDI_face.h"
#  include "MBC_byte.h"

#else /*** !DOS_FILENAMES *************************************************************/

#  include "MMMstorage.h"
#  include "MUP_types.h"
#  include "MUP_constants.h"
#  include "MEV_evaluate.h"
#  include "MST_stack.h"
#  include "MUT_utils.h"
#  include "MSG_signature.h"
#  include "MCM_compare.h"
#  include "MPA_parser.h" 
#  include "MPA_parser_help.h"
#  include "MSC_scan.h"
#  include "MTR_tree.h"
#  include "MIO_io.h"
#  include "MIO_local.h"
#  include "MSU_eval_subs.h"
#  include "MAM_ass_mem.h"
#  include "MAR_array.h"
#  include "MGS_simplify.h"
#  include "MTA_table.h"
#  include "MSR_string.h"
#  include "MSE_set.h"
#  include "MGR_constants.h"
#  include "MGR_types.h"
#  include "MGR_makro.h"
#  include "MGR_global.h"
#  include "MGR_extern.h"
#  include "MGR_color.h"
#  include "MGR_file.h"
#  include "MGR_defaults.h"
#  include "MGR_option_management.h"
#  include "MGR_calc.h"
#  include "MGR_util.h"
#  include "MGR_check.h"
#  include "MGR_command.h"
#  include "MGR_init.h"
#  include "MGR_sys_func.h"
#  include "MDF_diff.h"
#  include "MXP_expand.h"
#  include "MFO_open.h"
#  include "MFO_fileop.h"
#  include "MSY_sys_func.h"
#  include "MSY_sys_func_help.h"
#  include "MPL_parallel.h"
#  include "MTR_tree.h"
#  include "MSV_save.h"
#  include "MPH_problemheap.h"
#  include "MPO_poly.h"
#  include "MPO_poly_help.h"
#  include "MUP_funcs.h"
#  include "MDB_debug.h"
#  include "MHI_history.h"
#  include "MGH_message.h"
#  include "MLE_lineedit.h"
#  include "MDM_kern.h"
#  include "MNS_namespace.h"
#  include "MPM_match.h"
#  include "MUP_extern.h"
#  include "MUT_debug.h"
#  include "MDI_debug_interface.h"
#  include "MBC_bytecode.h"
#endif /* DOS_FILENAMES */

#ifdef MSDOS
#  include "MSW_int.h"
#endif

/******************************************************************************/
/*** Makros for internal usage ************************************************/
/******************************************************************************/

/*** Create a string from a given identifier **********************************/

#define MD_STRING(name)       #name

/******************************************************************************/
/*** Toolbox - constants ******************************************************/
/******************************************************************************/

/*** Length of charracter string buffer (refer to MFprintf) *******************/

#define MCbuflen    2048


/*** Boolean "C" constants ****************************************************/

#define MCtrue       ( (MUPbool) MUPC_constants_CAT_BOOL_TRUE    )
#define MCfalse      ( (MUPbool) MUPC_constants_CAT_BOOL_FALSE   )
#define MCunknown    ( (MUPbool) MUPC_constants_CAT_BOOL_UNKNOWN )


/*** Storage type of all MAMMUT objects created with this toolbox *************/

#define MCstorage    MMMCglobal

/*** Access mode for MAMMUT objects *******************************************/

#define MCread       MMMread
#define MCwrite      MMMwrite


/*** Constants to control MF service functions ********************************/

#define MCall        -1                                  /* must be negative! */
#define MCnone       -2                                  /* must be negative! */
#define MCthis       -3                                  /* must be negative! */
#define MCcopy       -4
#define MCaddr       (-5)


/*** Function control: kind of evaluation, remember table, special options ****/

#define MCnop          0      /* No Operation / Option                  ----- */
#define MChold         1      /* No evaluation of Arguments             Bit-0 */
#define MCremember     2      /* Function uses remember table           Bit-1 */
#define MCnoeval       4      /*                                        Bit-2 */
#define MChidden       8      /* Hidden module function                 Bit-3 */
#define MCstatic      16      /* Unremovable module function            Bit-4 */

#define MCdefault      MCnop  /* Default options                        Bit-? */


/*** The NULL elemnet of the memory management ********************************/

#define MCnull          MMMNULL


/*** Type Translation Table:  DOM_ <=> CAT_ ***********************************/

#define DOM_ANY         0                 /*** unbekannter Typ, vgl. MV_TTT ***/

#define DOM_APM         CAT_APM          
#define DOM_ARRAY       CAT_ARRAY        
#define DOM_BOOL        CAT_BOOL         
#define DOM_COMPLEX     CAT_COMPLEX       
#define DOM_DEBUG       CAT_DEBUG        
#define DOM_DOMAIN      CAT_DOM          
#define DOM_DYN_LIST    CAT_DYN_LIST     
#define DOM_ERROR       CAT_ERROR        
#define DOM_EXEC        CAT_EXEC         
#define DOM_EXPR        CAT_EXPR         
#define DOM_EXT         CAT_EXT          
#define DOM_FAIL        CAT_FAILED       
#define DOM_FLOAT       CAT_FLOAT        
#define DOM_FUNC        CAT_FUNC         
#define DOM_FUNCARG     CAT_FUNCARG      
#define DOM_FUNC_ENV    CAT_FUNC_ENV     
#define DOM_IDENT       CAT_IDENT        
#define DOM_INT         CAT_INT          
#define DOM_LIST        CAT_STAT_LIST    
#define DOM_MFLOAT      CAT_MFLOAT       
#define DOM_NAMESPACE   CAT_NAMESPACE    
#define DOM_NIL         CAT_NIL          
#define DOM_NULL        CAT_NULL         
#define DOM_POINT       CAT_POINT        
#define DOM_POLY        CAT_POLY         
#define DOM_POLYGON     CAT_POLYGON      
#define DOM_PROC        CAT_PROC         
#define DOM_RAT         CAT_RAT          
#define DOM_SET         CAT_SET_FINITE   
#define DOM_STRING      CAT_STRING       
#define DOM_TABLE       CAT_TABLE        
#define DOM_TASK        CAT_TASK         


/******************************************************************************/
/******************************************************************************/
/*** Global objects of MKT_func, must be declared at THIS location !!! ********/
/******************************************************************************/
/******************************************************************************/

/*** Variables defined and used by this toolbox *******************************/

#define      MKT_TTT_NUM      43
/* extern long  MKT_TTT[MKT_TTT_NUM];   Type Translation Table: DOM_ to MEVC_ */

extern long    MV_errnum;
extern char   *MV_errstr;
extern MTcell  MV_result;

/*** Prototypes of toolbox functions defined in 'MKT_func.c' ******************/

extern int     MFprintf1  ( char *format, va_list args );
extern char   *MFstring1  ( MTcell s, long option );
extern MTcell  MFrat1     ( MTcell numer, MTcell denom );
extern MTcell  MFrat2     ( long numer, long denom );
extern MTcell  MFcomplex1 ( MTcell re, MTcell im );
extern MTcell  MFcomplex2 ( long re, long im );
extern MTcell  MFnewExpr1 ( MTcell s, long n );
extern MTcell  MFnewExpr2 ( long n, va_list args );
extern MTcell  MFvalue1   ( MTcell s, MTcell t, long opt );
#ifndef GRAPHIC
extern MTcell  MFcall1    ( MTcell s, long n, va_list args );
#endif /*** GRAPHIC ***/

/******************************************************************************/
/*** Load module declarations and definitions. This is needed to reference ****/
/*** toolbox objects correctly, if dynamic linking is switched of !!!      ****/
/******************************************************************************/
#if defined ISMODULE || defined MD_MODULE
#  include "MDM_mod.h"
#endif


/******************************************************************************/
/******************************************************************************/
/*** Declaration and definiton of system and module functions *****************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
/*** Basic interface (for internal use only!) *********************************/
/******************************************************************************/

/*** The prototype of any system or module function ***************************/

#define MD_PROTOTYPE(MD_name) MTcell MD_name ( MTcell   MV_args,               \
                                               long     MV_prev_func,          \
                                               long     MV_eval_type,          \
                                               MTcell   MV_exec     )

/*** Macros to create names of system and module function. 'MD_SF_NAME' is ****/
/*** used for system functions.  'MD_KF_NAME' is used for module functions ****/
/*** that were moved into the kernel sources. Furthermore the module gene- ****/
/*** rator defined 'MD_MF_NAME' to name module functions within modules.   ****/

#define MD_SF_NAME(MD_name)        MD_name
#define MD_KF_NAME(MD_name)        MF_eval_ ## MD_name
#define MD_HIDDEN(MD_name)         __ ## MD_name

/*** Macros for an implizit declaration of module and system functions. To ****/
/*** make it possible to include module functions into the kernel sources, ****/
/*** module functions should be named with the macro 'MD_FUNC_NAME'.       ****/

#if defined ISMODULE || defined MD_MODULE
#  define MD_FUNC_NAME(MD_name)    MD_MF_NAME(MD_name)
#else
#  define MD_FUNC_NAME(MD_name)    MD_KF_NAME(MD_name)       
#endif
#define   MD_FUNC_DECL(MD_name)    MD_PROTOTYPE(MD_FUNC_NAME(MD_name))

/*** default init/exit code, macro to set remember table entries **************/

#define MD_INIT() {                                                            \
        if( !(MV_opt & MCnoeval) ) { /* for user-defined function headers */   \
            if( MV_opt & MChold ) {MV_eval_type |= MEVC_HOLD_BIT;}             \
            MEV_header( MV_args,                                               \
                    (long) MEVC_NULL_DEFAULT,                                  \
                    MV_prev_func, MV_eval_type, MV_exec,                       \
                    (long) MGSC_FLAT_ARG,                                      \
                    (long) MEVC_UNKNOWN,                                       \
                    &MVargs, 0L, MV_type,                                      \
                    (long) MEVC_NO_OVERLOAD, 0L, 0L, 0L                        \
            );                                                                 \
        } else {                                                               \
            MVargs = MV_args;                                                  \
            MMMcopy(MV_args);                                                  \
        }                                                                      \
        if( !(MV_opt & MCremember) ) {MEV_set_mam_control(MAMC_NO_WRITE_UP);}  \
}

#define MD_EXIT() {                                                            \
        {MMMfree(MVargs);}                                                     \
}

#define MD_REMTAB(MD_result) {                                                 \
        if( MV_opt & MCremember ) {	                                       \
          if(MMMequal(*MMMP(&MV_exec,3,MMMread),VALUE_READ(MUPV_CAT_NIL))){    \
             MMMfree(*MMMP(&MV_exec,3,MMMwrite));                              \
             *MMMP(&MV_exec,3,MMMwrite) = MTA_new_table(MMMCglobal);           \
             MMMinactiv(&MV_exec);                                             \
          }                                                                    \
          MTA_write_table(MMMP(&MV_exec,3,MMMread),MVargs,MTAC_FUNC,MD_result);\
	}                                                                      \
}

/*** The string  MD_MODSTR  contains the prefix of a function name. This is ***/
/*** "" for all kernel functions and something like "foo::" for module fun- ***/
/*** ctions. In the seconds case MD_MODSTR is defined by 'mmg'.             ***/

#ifndef MD_MODULE
#  define MD_MODSTR  ""
#endif

/*** Macro to define a module or system function, respectivly. The function ***/
/*** definiton consists of five parts:                                      ***/
/***                                                                        ***/
/***      MD_name     - basename of the function; the user's function name, ***/
/***                    also stored and used for error messages             ***/
/***      MD_options  - e.g.: MCdefault, MChold, MCremember,... to control  ***/
/***                    a special behaviour of the function.  Some options  ***/
/***                    may be dummies, only analysed and used by 'mmg'.    ***/
/***      MD_type     - CAT_ type of the function's result                  ***/
/***      MD_init     - name of the functions initialization code. This is  ***/
/***                    usually a macro, called with the arguments MD_name  ***/
/***                    MD_options and MD_ftype.                            ***/
/***      MD_body     - a {}-block, the body of the function                ***/
/***                                                                        ***/
#define MD_FUNC_HEADER( MD_name, MD_options, MD_type, MD_init )                \
        MD_FUNC_DECL(MD_name)                                                  \
        {                                                                      \
             jmp_buf      MV_jump;                                             \
             MTcell       MVargs;                         /* evaluated args */ \
             long         MV_opt    = MD_options;         /* func. options  */ \
             long         MV_type   = MD_type;            /* result type    */ \
             const char*  MV_name = MD_STRING(MD_name);                        \
                                                                               \
             {MD_init()}                                  /* initialization */ \
                                                                               \
             MV_errnum = 0;                                                    \
             MV_errstr = "unknown";                                            \
             memcpy((char*)MV_jump,(char*)MPAV_JumpLabel,sizeof(jmp_buf));     \
             if( setjmp(MPAV_JumpLabel) ) {               /* handle failure */ \
                 memcpy((char*)MPAV_JumpLabel,(char*)MV_jump,sizeof(jmp_buf)); \
                 if( MV_errnum > 0 ) {                                         \
                     char     buf[1024];                                       \
                     sprintf( buf, "%s [%s%s]", MV_errstr,MD_MODSTR,MV_name ); \
                     {MD_EXIT()}                                               \
                     MEV_set_error(MV_errnum,buf);                             \
                 } else if( MV_errnum < 0 ) {                                  \
                     MUP_set_sign(MV_args,MV_result);                          \
                     MD_REMTAB(MV_result);                                     \
                     {MD_EXIT()}                                               \
                     return( MV_result );                                      \
                 } else {                                                      \
                     longjmp(MPAV_JumpLabel,1);                                \
                 }                                                             \
             } else {                                                          

#define MD_FUNC_FOOTER()                                                       \
             }                                                                 \
             return(MCnull) ;                                                  \
        }

#define MD_FUNC_DEF( MD_name, MD_options, MD_type, MD_init, MD_body )          \
        MD_FUNC_HEADER(MD_name,MD_options,MD_type,MD_init)                     \
        {MD_body}                                                              \
        MD_FUNC_FOOTER()                                                       

/******************************************************************************/
/*** Declaration and definiton of s & m functions (user interface) ************/
/******************************************************************************/

/*** Macros for explicit declarations of system or module functions. The ******/
/*** macro MD_MF_NAME is defined by 'mmg' accroding to the module name.  ******/

#define MF_SYS_FUNC(MD_name)     MD_PROTOTYPE(MD_name)
#define MF_MOD_FUNC(MD_name)     MD_PROTOTYPE(MD_MF_NAME(MD_name))

/*** Declaration/Definition of m functions with a standard initialization *****/

#define MF_FUNC_NAME(MD_name)                                                  \
        MD_FUNC_NAME(MD_name)
        
#define MF_FUNC_DECL(MD_name)                                                  \
        MD_FUNC_DECL(MD_name)
        
#ifdef MMG_NEW_STYLE
#  define MFUNC(MD_name, MD_options)                                           \
          MD_FUNC_HEADER( MD_name, MD_options, MEVC_NO_TYPE_CHECK, MD_INIT )
#  define MFEND                                                                \
          MD_FUNC_FOOTER()
#else
#  define MFUNC(MD_name, MD_options, MD_body)                                  \
          MD_FUNC_DEF(MD_name,MD_options,MEVC_NO_TYPE_CHECK,MD_INIT,MD_body)
#  define MFEND 
#endif

/******************************************************************************/
/******************************************************************************/
/*** Memory Management ********************************************************/
/******************************************************************************/
/******************************************************************************/

/*** Basic interface (for internal use only) **********************************/

#define MFcat(s_)  (MMMZ(&(s_), CATEGORY, MMMread)->cat )
#define MFspec(s_) (MMMZ(&(s_), CATEGORY, MMMread)->spec)
#define MFext(s_)  ((CATEGORY_EXT*)(MMMZ(&(s_),char,MMMread)+sizeof(CATEGORY)))->ext


/******************************************************************************/
/* NAME:        MFmmmstring                                                   */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns the address of the C string of the MMM_STRING 's'     */
/******************************************************************************/
inline char *MFmmmstring ( MTcell s )
{
    char *cstr = MMMmv(&s, sizeof(STRSIZE), char,  MMMread); 

    MMMinactiv(&s); 
    return(cstr); 
}

/*** User interface ***********************************************************/

/******************************************************************************/
/* NAME:        MFhasXXX                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Checks whether 's' has any special bits.                      */
/******************************************************************************/
inline MUPbool MFhasMinus ( MTcell s ) { return( MFspec(s) & MINUS_BIT ); }
inline MUPbool MFhasDiv   ( MTcell s ) { return( MFspec(s) & DIV_BIT   ); }
inline MUPbool MFhasNot   ( MTcell s ) { return( MFspec(s) & NOT_BIT   ); }
inline MUPbool MFhasSpec  ( MTcell s ) { 
       return( MFspec(s) & (MINUS_BIT | DIV_BIT | NOT_BIT) ); 
}

/******************************************************************************/
/* NAME:        MFdom                                                         */
/* PARAMETER:   s = Any category (MTcell)                                     */
/* FUNKTION:    Returns the domain (basic type) of a category 's'.            */
/******************************************************************************/
inline short MFdom ( MTcell s )
{
    short c = MFcat(s);

    MMMinactiv(&s);
    return(c);
}

/******************************************************************************/
/* NAME:        MFcopy                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Creates a logical copy (side-effect) of 's' and returns 's'.  */
/******************************************************************************/
inline MTcell MFcopy ( MTcell s )
{
    MMMcopy(s);
    return(s);
}

/******************************************************************************/
/* NAME:        MFchange                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Creates a physical copy (side-effect) of 's' and returns it.  */
/******************************************************************************/
inline MTcell MFchange ( MTcell *s )
{
    MMMchange(s);
    return(*s);
}

/******************************************************************************/
/* NAME:        MFfree                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Frees 's' (side-effect).                                      */
/******************************************************************************/
inline void MFfree ( MTcell s ) {
       MMMfree(s);
}

/******************************************************************************/
/* NAME:        MFnops                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns the number of operands of 's'.                        */
/******************************************************************************/
inline long MFnops ( MTcell s ) {
       return( MMMcounter(s) );
}

/******************************************************************************/
/* NAME:        MFnops                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Changes the number of operands of 's' to 'n'.                 */
/******************************************************************************/
inline void MFnops ( MTcell *s, long n ) {
       MMMnewcounter(s,n);
}

/******************************************************************************/
/* NAME:        MFopAdr                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Returns a pointer to the n-th operand of 's'.                 */
/******************************************************************************/
inline MTcell* MFopAdr ( MTcell s, long n )
{
    MTcell *son = MMMP(&s,n,MMMwrite);
    
    MMMinactiv(&s);
    return(son);
}

/******************************************************************************/
/* NAME:        MFopGet                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Returns the n-th operand of 's'.                              */
/******************************************************************************/
inline MTcell MFopGet ( MTcell s, long n ) {
       return( *MFopAdr(s,n) );
}

/******************************************************************************/
/* NAME:        MFopSet                                                       */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/*              t = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Sets the n-th operand of 's' to 't' and returns 't'.          */
/******************************************************************************/
inline MTcell MFopSet ( MTcell s, long n, MTcell t )
{
    *MMMP(&s,n,MMMwrite) = t;
    MMMinactiv(&s);
    return(t);
}

/******************************************************************************/
/* NAME:        MFop                                                          */
/* FUNKTION:    Refer to 'MFopGet'. 'MFop' should not be used in this file!   */
/******************************************************************************/
inline MTcell MFop ( MTcell s, long n ) {
       return( MFopGet(s, n) );
}
 
/******************************************************************************/
/* NAME:        MFop                                                          */
/* FUNKTION:    Refer to 'MFopSet'. 'MFop' should not be used in this file!   */
/******************************************************************************/
inline MTcell MFop ( MTcell s, long n, MTcell t ) {
       return( MFopSet(s, n, t) );
}
 
/******************************************************************************/
/* NAME:        MFopFree                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/* FUNKTION:    Frees the n-th operand of 's'.                                */
/******************************************************************************/
inline void MFopFree ( MTcell s, long n ) {
       MFfree( MFopGet(s,n) );
}

/******************************************************************************/
/* NAME:        MFopSubs                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = Index in the range [0 .. MFnops(s)-1] (long)              */
/*              t = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Creates a physical copy of 's' to prevent side-effects, Frees */
/*              the n-th operand of 's' and sets it to 't'. 't' is NOT COPIED */
/*              with this!                                                    */
/******************************************************************************/
inline void MFopSubs ( MTcell *s, long n, MTcell t )
{
    MFcopy( *s );
    MFchange( s );
    MFfree( MFopGet(*s,n) );
    MFopSet( *s, n, t );
}

/******************************************************************************/
/* NAME:        MFsize                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns the length of the memory part of 's'.                 */
/******************************************************************************/
inline long MFsize ( MTcell s ) {
       return( MMMsize(s) );
}

/******************************************************************************/
/* NAME:        MFsize                                                        */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/*              n = New length of the mem part (long)                         */
/* FUNKTION:    Changes the length of the memory part of 's' to 'n'.          */
/******************************************************************************/
inline void MFsize ( MTcell *s, long n ) {
       MMMresize(s, n);
}

/******************************************************************************/
/* NAME:        MFmemGet                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns a  'Read' Pointer to the memory part of 's'. Do not   */
/*              forget to use 'MFinactive' after using this Pointer!!!!!!!!   */
/******************************************************************************/
inline char* MFmemGet ( MTcell s ) {
       return( (char*) MMMZ(&s,char*,MCread) );
}

/******************************************************************************/
/* NAME:        MFmemSet                                                      */
/* PARAMETER:   s = Any MuPAD value (MTcell)                                  */
/* FUNKTION:    Returns a 'Write' Pointer to the memory part of 's'. Do not   */
/*              forget to use 'MFinactive' after using this Pointer!!!!!!!!   */
/******************************************************************************/
inline char* MFmemSet ( MTcell s ) {
       return( (char*) MMMZ(&s,char*,MCwrite) );
}

/******************************************************************************/
/* NAME:        MFinactive                                                    */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Set a cell to state 'inactive' after accessing its operands.  */
/******************************************************************************/
#define MFinactive                                                            \
        MMMinactiv

/******************************************************************************/
/* NAME:        MFpoolInsert                                                  */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Inserts '*s' into the pool of non-moveable memory.            */
/******************************************************************************/
#define MFpoolInsert                                                           \
        MMMpoolinsert

/******************************************************************************/
/* NAME:        MFpoolDelete                                                  */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Removes '*s' from the pool of non-moveable memory.            */
/******************************************************************************/
#define MFpoolDelete                                                           \
        MMMpooldelete

/******************************************************************************/
/* NAME:        MFsig                                                         */
/* PARAMETER:   s = Any MuPAD value (MTcell**)                                */
/* FUNKTION:    Calculate the signature of cell 's'.                          */
/******************************************************************************/
inline void MFsig( MTcell s ) {
       MSG_sig(s);
}

/******************************************************************************/
/* NAME:        MFcmalloc                                                     */
/* PARAMETER:   n = Size of block to be allocated                             */
/* FUNKTION:    Allocated a memory block directly from the operating system.  */
/******************************************************************************/
inline void* MFcmalloc( size_t n ) {
       return( MMMEmalloc(n) );
}

/******************************************************************************/
/* NAME:        MFcfree                                                       */
/* PARAMETER:   -                                                             */
/* FUNKTION:    Frees a memory block allocated with 'MFcmalloc'.              */
/******************************************************************************/
inline void MFcfree( void* p ) {
#ifdef SUNOS4
       MMMEfree((char*)p);
#else
       MMMEfree(p);
#endif
}


/******************************************************************************/
/******************************************************************************/
/*** Controlling of s/m functions defined with MF??? **************************/
/******************************************************************************/
/******************************************************************************/

/*** Accessing unevaluated and evaluated function arguments *******************/

/******************************************************************************/
/* NAME:        MV_nargs                                                      */
/* FUNKTION:    Number of arguments passed to the function (unevaluated!).    */
/******************************************************************************/
#define MV_nargs                                                               \
        ( MFnops(MV_args)-1 )

/******************************************************************************/
/* NAME:        MF_arg                                                        */
/* PARAMETER:   n = Index of a function argument (long).                      */
/* FUNKTION:    The 'n'-th argument passed to the function (unevaluated!).    */
/******************************************************************************/
#define MF_arg( n )                                                            \
        MFopGet(MV_args,n)

/******************************************************************************/
/* NAME:        MVnargs                                                       */
/* FUNKTION:    Number of arguments passed to the function (evaluated!).      */
/******************************************************************************/
#define MVnargs	( MFnops(MVargs)-1 )

/******************************************************************************/
/* NAME:        MFarg                                                         */
/* PARAMETER:   n = Index of a function argument (long).                      */
/* FUNKTION:    The 'n'-th argument passed to the function (evaluated!).      */
/******************************************************************************/
#define MFarg( n )                                                             \
        MFopGet(MVargs,n)

/******************************************************************************/
/* NAME:        MFnargsCheck                                                  */
/* PARAMETER:   n = Number of arguments that are allowed.                     */
/* FUNKTION:    Sets an error if the number of argument is unequal to 'n'.    */
/******************************************************************************/
#define MFnargsCheck( n ) {                                                    \
        if( MVnargs != n )                                                     \
            MFerror( "Wrong number of arguments" );                            \
}

/******************************************************************************/
/* NAME:        MFnargsCheckRange                                             */
/* PARAMETER:   n,m = Min/Max number of arguments that are allowed.           */
/* FUNKTION:    Sets an error if the number of argument is unequal to 'n'.    */
/******************************************************************************/
#define MFnargsCheckRange( n, m ) {                                            \
        if( MVnargs < n || MVnargs > m )                                       \
            MFerror( "Wrong number of arguments" );                            \
}

/******************************************************************************/
/* NAME:        MFargCheck                                                    */
/* PARAMETER:   n = Index of argument                                         */
/*              t = Expected type of argument                                 */
/* FUNKTION:    Sets an error if MFarg(n) is not of type 't'.                 */
/******************************************************************************/
#define MFargCheck( n, t ) {                                                   \
        if( MFdom(MFarg(n)) != t )                                             \
            MFerror( "Invalid argument" );                                     \
}

/*** Init and exit code for module functions **********************************/

/******************************************************************************/
/* NAME:        MFexit                                                        */
/* PARAMETER:   -                                                             */
/* FUNKTION:    Free memory allocated by the standard initialization header   */
/******************************************************************************/
#define MFexit                                                                 \
        MD_EXIT

/******************************************************************************/
/* NAME:        MFreturn                                                      */
/* PARAMETER:   result = return value of the system/module function           */
/* FUNKTION:    Call exit code, update sign- bits and return function result  */
/******************************************************************************/
#define MFreturn( result )                                                     \
{                                                                              \
    MTcell   _xxxtmp = result;                                                 \
                                                                               \
    MUP_set_sign(MV_args,_xxxtmp);                                             \
    MD_REMTAB(_xxxtmp);                                                        \
    MFexit();                                                                  \
    memcpy((char*)MPAV_JumpLabel,(char*)MV_jump,sizeof(jmp_buf));              \
    return( _xxxtmp );                                                         \
}

#define MFreturnAsync( result )                                                \
{                                                                              \
    GLOBAL_WRITE(MV_errnum, -1 );                                              \
    GLOBAL_WRITE(MV_errstr, "async" );                                         \
    GLOBAL_WRITE(MV_result, result );                                          \
    longjmp(MPAV_JumpLabel, 1);                                                \
}

    

/******************************************************************************/
/* NAME:        MFerror                                                       */
/* PARAMETER:   func = Name of the function in which this error occured.      */
/*              text = Error string.                                          */
/* FUNKTION:    Generates an error exception. (Only for use in MF_FUNC!)      */
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFerror                                                       */
/* PARAMETER:   text = Error string.                                          */
/* FUNKTION:    Generates an error exception. (Only for use in MF_FUNC!)      */
/******************************************************************************/
#define MFerror( text )                                                        \
{                                                                              \
    GLOBAL_WRITE(MV_errnum, MEVC_USER_DEFINED_ERROR );                         \
    GLOBAL_WRITE(MV_errstr, text);                                             \
    longjmp(MPAV_JumpLabel, 1);                                                \
}


/******************************************************************************/
/******************************************************************************/
/*** Constant values **********************************************************/
/******************************************************************************/
/******************************************************************************/

/*** Boolean constants ********************************************************/

#define MVtrue           VALUE_READ( MUPV_CAT_BOOL_TRUE    )
#define MVfalse          VALUE_READ( MUPV_CAT_BOOL_FALSE   )
#define MVunknown        VALUE_READ( MUPV_CAT_BOOL_UNKNOWN )

/*** Some special arithmetic constants ****************************************/

#define MVi              VALUE_READ( MCAC_ci               )

#define MVzero           VALUE_READ( MCAC_zero             )
#define MVhalf           VALUE_READ( MCAC_half             )
#define MVone            VALUE_READ( MCAC_one              )
#define MVone_           VALUE_READ( MCAC_one_             )
#define MVtwo            VALUE_READ( MCAC_two              )
#define MVtwo_           VALUE_READ( MCAC_two_             )

/*** Other special constants **************************************************/

#define MVfail           VALUE_READ( MUPV_CAT_FAILED       )
#define MVnil            VALUE_READ( MUPV_CAT_NIL          )
#define MVnull           VALUE_READ( MUPV_CAT_NULL         )



/******************************************************************************/
/*** Convert basic types (MUPbools,numbers,strings,identifiers) ***************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFbool                                                        */
/* PARAMETER:   s = An element of type DOM_BOOL (MTcell)                      */
/* FUNKTION:    According to 's' it returns MCtrue, MCfalse or MCunknown.     */
/******************************************************************************/
inline MUPbool MFbool ( MTcell s )
{
    short e = MFext(s);
   
    MMMinactiv(&s);
    return( (MUPbool) e );
}

/******************************************************************************/
/* NAME:        MFbool                                                        */
/* PARAMETER:   v = One of the values MCtrue, MCfalse or MCunknown            */
/* FUNKTION:    According to 'v' it returns MVtrue, MVfalse or MVunknown.     */
/******************************************************************************/
inline MTcell MFbool ( MUPbool v )
{
    switch( v ) {
      case MCtrue   : return( MFcopy(MVtrue   ) );
      case MCfalse  : return( MFcopy(MVfalse  ) );
      case MCunknown: return( MFcopy(MVunknown) );
      default       : return( MFcopy(MVfail   ) );
    }
}

/******************************************************************************/
/* NAME:        MFfloat                                                       */
/* PARAMETER:   Refer to MFdouble                                             */
/* FUNKTION:    Refer to MFdouble - for compatibility                         */
/******************************************************************************/
#define MFfloat MFdouble

/******************************************************************************/
/* NAME:        MFdouble                                                      */
/* PARAMETER:   s = An element of type DOM_FLOAT (MTcell)                     */
/* FUNKTION:    Returns a C double of 's'.                                    */
/******************************************************************************/
inline double MFdouble ( MTcell s )
{
    return( MCA_cat_to_double(s) );
}

/******************************************************************************/
/* NAME:        MFdouble                                                      */
/* PARAMETER:   v = A floating point number (double)                          */
/* FUNKTION:    Returns a DOM_FLOAT of the value 'v'.                         */
/******************************************************************************/
inline MTcell MFdouble ( double v )
{
    return( MCA_new_cat_pari(MCstorage, MCA_double_to_pari(v)) );
}

/******************************************************************************/
/* NAME:        MFstring                                                      */
/* PARAMETER:   s = A character string (DOM_STRING)                           */
/* FUNKTION:    Returns the address of the C string of the DOM_STRING 's'     */
/******************************************************************************/
inline char *MFstring  ( MTcell s, long option=MCaddr) {
       return( MFstring1(s, option) );
}

/******************************************************************************/
/* NAME:        MFstring                                                      */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a DOM_STRING of the value 'v'.                        */
/******************************************************************************/
inline MTcell MFstring ( char *v ) {
       return( MTR_new_cat_string(MCstorage,v) );
}

/******************************************************************************/
/* NAME:        MFident                                                       */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a DOM_IDENT of the value 'v'.                         */
/******************************************************************************/
inline MTcell MFident ( char *v ) {
       return( MTR_new_cat_ident(MCstorage,v) );
}

/******************************************************************************/
/* NAME:        MFident                                                       */
/* PARAMETER:   v = A character string (char*)                                */
/* FUNKTION:    Returns a pointer to the C character string.                  */
/******************************************************************************/
inline char* MFident ( MTcell s, long option=MCaddr ) {
       return( MFstring1(s,option) );
}

/******************************************************************************/
/* NAME:        MFint                                                         */
/* PARAMETER:   Refer to MFlong                                               */
/* FUNKTION:    Refer to MFlong - for compatibility                           */
/******************************************************************************/
#define MFint MFlong

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   v = An integer (long)                                         */
/* FUNKTION:    Returns a DOM_INT of the value 'v'.                           */
/******************************************************************************/
inline MTcell MFlong ( long v ) {
       return( MCA_set_long(v) );
}

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   v = An integer                                                */
/* FUNKTION:    Returns a DOM_INT of the value 'v'.                           */
/******************************************************************************/
inline MTcell MFlong ( int  v ) {
       return( MFlong((long)v) );
}

/******************************************************************************/
/* NAME:        MFlong                                                        */
/* PARAMETER:   s = An element of type DOM_FLOAT (MTcell)                     */
/* FUNKTION:    Returns a C long of 's'.                                      */
/******************************************************************************/
inline long MFlong ( MTcell s ) {
       return( MCA_cat_to_int(s) );
}

/******************************************************************************/
/* NAME:        MFrat                                                         */
/* PARAMETER:   numer = Numerator (DOM_INT)                                   */
/*              denom = Denominator  (DOM_INT)                                */
/* FUNKTION:    Returns a DOM_RAT of the value 'numer/denom'.                 */
/******************************************************************************/
inline MTcell MFrat ( MTcell numer, MTcell denom ) {
       return( MFrat1(numer,denom) );
}

/******************************************************************************/
/* NAME:        MFrat                                                         */
/* PARAMETER:   numer = Numerator (long)                                      */
/*              denom = Denominator  (long)                                   */
/* FUNKTION:    Returns a DOM_RAT of the value 'numer/denom'.                 */
/******************************************************************************/
inline MTcell MFrat ( long numer, long denom ) {
       return( MFrat2(numer,denom) );
}

/******************************************************************************/
/* NAME:        MFratNum                                                      */
/* PARAMETER:   s = A rational number (DOM_RAT)                               */
/* FUNKTION:    Returns the numerator (DOM_INT) of the number 's'.            */
/******************************************************************************/
inline MTcell MFratNum ( MTcell s ) {
       return( MCA_new_cat_pari(MCstorage, numer(MCA_cat_to_pari(s))) );
}

/******************************************************************************/
/* NAME:        MFratDen                                                      */
/* PARAMETER:   s = A rational number (DOM_RAT)                               */
/* FUNKTION:    Returns the numerator (DOM_INT) of the number 's'.            */
/******************************************************************************/
inline MTcell MFratDen ( MTcell s ) {
       return( MCA_new_cat_pari(MCstorage, denom(MCA_cat_to_pari(s))) );
}

/******************************************************************************/
/* NAME:        MFcomplex                                                     */
/* PARAMETER:   re = Real part (long)                                         */
/*              im = Imaginary part  (long)                                   */
/* FUNKTION:    Returns a DOM_COMPLEX of the value 're+im*I'.                 */
/******************************************************************************/
inline MTcell MFcomplex ( MTcell re, MTcell im ) {
       return( MFcomplex1(re,im) );
}

/******************************************************************************/
/* NAME:        MFcomplex                                                     */
/* PARAMETER:   re = Real part (long)                                         */
/*              im = Imaginary part  (long)                                   */
/* FUNKTION:    Returns a DOM_COMPLEX of the value 're+im*I'.                 */
/******************************************************************************/
inline MTcell MFcomplex ( long re, long im ) {
       return( MFcomplex2(re,im) );
}

/******************************************************************************/
/* NAME:        MFcomplexIm                                                   */
/* PARAMETER:   s = A complex number (DOM_COMPLEX)                            */
/* FUNKTION:    Returns the real part of the number 's'.                      */
/******************************************************************************/
inline MTcell MFcomplexRe ( MTcell s ) {
       return( MCA_complex_re(s) );
}

/******************************************************************************/
/* NAME:        MFcomplexIm                                                   */
/* PARAMETER:   s = A complex number (DOM_COMPLEX)                            */
/* FUNKTION:    Returns the imaginary part of the number 's'.                 */
/******************************************************************************/
inline MTcell MFcomplexIm ( MTcell s ) {
       return( MCA_complex_im(s) );
}



/******************************************************************************/
/******************************************************************************/
/*** Types and Typechecking ***************************************************/
/******************************************************************************/
/******************************************************************************/

/*** User interface ***********************************************************/

inline MUPbool MFisApm       ( MTcell s ) { return( MFdom(s)==DOM_APM       ); }
inline MUPbool MFisArray     ( MTcell s ) { return( MFdom(s)==DOM_ARRAY     ); }
inline MUPbool MFisBool      ( MTcell s ) { return( MFdom(s)==DOM_BOOL      ); }
inline MUPbool MFisComplex   ( MTcell s ) { return( MFdom(s)==DOM_COMPLEX   ); }
inline MUPbool MFisDebug     ( MTcell s ) { return( MFdom(s)==DOM_DEBUG     ); }
inline MUPbool MFisDomain    ( MTcell s ) { return( MFdom(s)==DOM_DOMAIN    ); }
inline MUPbool MFisExec      ( MTcell s ) { return( MFdom(s)==DOM_EXEC      ); }
inline MUPbool MFisExt       ( MTcell s ) { return( MFdom(s)==DOM_EXT       ); }
inline MUPbool MFisExpr      ( MTcell s ) { return( MFdom(s)==DOM_EXPR      ); }
inline MUPbool MFisFail      ( MTcell s ) { return( MFdom(s)==DOM_FAIL      ); }
inline MUPbool MFisFloat     ( MTcell s ) { return( MFdom(s)==DOM_FLOAT     ); }
inline MUPbool MFisFunc      ( MTcell s ) { return( MFdom(s)==DOM_FUNC      ); }
inline MUPbool MFisFuncArg   ( MTcell s ) { return( MFdom(s)==DOM_FUNCARG   ); }
inline MUPbool MFisFuncEnv   ( MTcell s ) { return( MFdom(s)==DOM_FUNC_ENV  ); }
inline MUPbool MFisIdent     ( MTcell s ) { return( MFdom(s)==DOM_IDENT     ); }
inline MUPbool MFisInt       ( MTcell s ) { return( MFdom(s)==DOM_INT       ); }
inline MUPbool MFisList      ( MTcell s ) { return( MFdom(s)==DOM_LIST      ); }
inline MUPbool MFisNamespace ( MTcell s ) { return( MFdom(s)==DOM_NAMESPACE ); }
inline MUPbool MFisNil       ( MTcell s ) { return( MFdom(s)==DOM_NIL       ); }
inline MUPbool MFisNull      ( MTcell s ) { return( MFdom(s)==DOM_NULL      ); }
inline MUPbool MFisProc      ( MTcell s ) { return( MFdom(s)==DOM_PROC      ); }
inline MUPbool MFisPoint     ( MTcell s ) { return( MFdom(s)==DOM_POINT     ); }
inline MUPbool MFisPolygon   ( MTcell s ) { return( MFdom(s)==DOM_POLYGON   ); }
inline MUPbool MFisPolynom   ( MTcell s ) { return( MFdom(s)==DOM_POLY      ); }
inline MUPbool MFisRat       ( MTcell s ) { return( MFdom(s)==DOM_RAT       ); }
inline MUPbool MFisSet       ( MTcell s ) { return( MFdom(s)==DOM_SET       ); }
inline MUPbool MFisString    ( MTcell s ) { return( MFdom(s)==DOM_STRING    ); }
inline MUPbool MFisTable     ( MTcell s ) { return( MFdom(s)==DOM_TABLE     ); }
inline MUPbool MFisTask      ( MTcell s ) { return( MFdom(s)==DOM_TASK      ); }

/*** Identify any type of a number ********************************************/

inline MUPbool MFisNumber ( MTcell s ) { return( MFisApm(s) || MFisComplex(s) ||
                                         MFisFloat(s) || MFisInt(s) || MFisRat(s) ); }

/*** Identify MUPbool constants ***********************************************/

inline MUPbool MFisTrue    ( MTcell s ) { 
       return( MFisBool(s) && MFbool(s) == MCtrue   ); }
inline MUPbool MFisFalse   ( MTcell s ) { 
       return( MFisBool(s) && MFbool(s) == MCfalse  ); }
inline MUPbool MFisUnknown ( MTcell s ) { 
       return( MFisBool(s) && MFbool(s) == MCunknown); }

/*** Identify special arithmetic constants ************************************/

inline MUPbool MFisZero    ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVzero) ); }
inline MUPbool MFisOne     ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVone ) ); }
inline MUPbool MFisHalf    ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVhalf) ); }
inline MUPbool MFisOne_    ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVone_) ); }
inline MUPbool MFisTwo     ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVtwo ) ); }
inline MUPbool MFisTwo_    ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVtwo_) ); }
inline MUPbool MFisI       ( MTcell s ) { return( (MUPbool) MCM_equal(s,MVi   ) ); }

/*** Identify special expressions *********************************************/

/******************************************************************************/
/* NAME:        MFisExpr                                                      */
/* PARAMETER:   s    = Any category (MTcell)                                  */
/*              type = type of expression (long), refer to MUP_constants.h    */
/* FUNKTION:    Returns _true_ if 's' is an expression of type 'type'.        */
/******************************************************************************/
inline MUPbool MFisExpr ( MTcell s, long type )
{
    if( !MFisExpr(s) ) {
        return( _false_ );
    } else {
        MTcell   ident = *MMMP(&s,0L,MMMread);

        MMMinactiv(&s);
	if( MCM_compare_MMMstring_ident(MTRV_SYS_FUNC_LIST[type],ident) )
            return _true_;
	else
            return _false_;
    }
}

/******************************************************************************/
/* NAME:        MFisExpr                                                      */
/* PARAMETER:   s    = Any category (MTcell)                                  */
/*              type = A type of an expression (char*)                        */
/* FUNKTION:    Returns _true_ if 's' is an expression of type 'type'.        */
/******************************************************************************/
inline MUPbool MFisExpr ( MTcell s, char *name ) 
{ 
    if( !MFisExpr(s) ) {
        return( _false_ );
    } else {
        MTcell   ident = *MMMP(&s,0L,MMMread);

        MMMinactiv(&s);
	if( strcmp(MFident(ident),name) == 0 )
            return _true_;
        else
            return( _false_ );
    }
}


/******************************************************************************/
/******************************************************************************/
/*** Further service functions ************************************************/
/******************************************************************************/
/******************************************************************************/


/******************************************************************************/
/******************************************************************************/
/*** Create non-atomic objects that cannot be converted from C objects ********/
/******************************************************************************/
/******************************************************************************/

inline MTcell MFnewComplex ( MTcell re, MTcell im ) {
       return( MFcomplex(re,im) );
}
inline MTcell MFnewComplex ( long re, long im ) {
       return( MFcomplex(re,im) );
}

inline MTcell MFnewDebug ( unsigned long value ) {
       return( MTR_new_cat_debug(MCstorage, value) ); 
}

inline MTcell MFnewDomain ( MTcell key, MUPbool *is_new ) {
       return( MEE_get_domain(key, is_new ) ); 
}

inline MTcell MFnewExec ( long n ) {
       return( MTR_new_cat_exec(MCstorage, n) ); 
}

inline MTcell MFnewExpr ( MTcell s, long n=0 ) {
       return( MFnewExpr1(s, n) );
}
inline MTcell MFnewExpr ( long n  Mva_arglist ) {
       MTcell expr;

       Mva_start( args, n );
       expr = MFnewExpr2( n, args );
       Mva_end( args );
       return( expr );
}

inline MTcell MFnewExt ( MTcell dom, long n ) {
       MTcell ext = MTR_new_cat_ext(MCstorage, n);
       MFopSet( ext, 0, MFcopy(dom) );
       return( ext ); 
}

inline MTcell MFnewExt ( long n ) {
       return( MTR_new_cat_ext(MCstorage, n) ); 
}

inline MTcell MFnewFloat ( float v ) {
       return( MFfloat(v) );
}
inline MTcell MFnewFloat ( double v ) {
       return( MFdouble(v) );
}

inline MTcell MFnewFuncArg ( long n ) {
       return( MTR_new_cat_funcarg(MCstorage, n) ); 
}

inline MTcell MFnewFuncEnv ( VOID ) {
       return( MTR_new_cat_func_env(MCstorage) ); 
}

inline MTcell MFnewInt ( long v ) {
       return( MFlong(v) );
}
inline MTcell MFnewInt ( int v ) {
       return( MFlong(v) );
}

inline MTcell MFnewList ( long n ) {
       return( MTR_new_cat_stat_list(MCstorage, n) ); 
}

inline MTcell MFnewPoint ( MTcell x, MTcell y, MTcell z, MTcell color=MVnil ) {
       return( MTR_new_cat_point(MCstorage, x, y, z, color) ); 
}

inline MTcell MFnewPolygon ( long n, MTcell *pv  = NULL, MTcell color = MVnil, 
                             MTcell closed = MVfalse, MTcell filled = MVnil ) {
       return( MTR_new_cat_polygon(MCstorage, n, pv, color, closed, filled) ); 
}

inline MTcell MFnewProc ( long n ) {
       return( MTR_new_proc(MCstorage, n) ); 
}

inline MTcell MFnewRat ( MTcell numer, MTcell denom ) {
       return( MFrat(numer,denom) );
}
inline MTcell MFnewRat ( long numer, long denom ) {
       return( MFrat(numer,denom) );
}

inline MTcell MFnewSet ( VOID ) {
       return( MSE_new_set(MCstorage) ); 
}

inline MTcell MFnewTable ( VOID ) {
       return( MTA_new_table(MCstorage) ); 
}

inline MTcell MFnewTask ( VOID ) {
       return( MTR_new_cat_task(MCstorage) ); 
}


/******************************************************************************/
/*** Get/Set objects: Identifiers, Tables, ... ********************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFvalue                                                       */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Get (set a value 't') in/from the container object 's'.       */
/******************************************************************************/
inline MTcell MFvalue  ( MTcell s, MTcell t=MCnull, long opt=0 ) {
       return( MFvalue1(s, t, opt) );
}

inline MTcell MFgetDomain( MTcell *s, MTcell t ) {
       return( MEE_domain_in(*s,t) );
}
inline MTcell MFsetDomain( MTcell *s, MTcell t, MTcell v ) {
       MEE_domain_insert( s, t, v );
       return( v );
}

inline MTcell MFgetList( MTcell *s, long n ) {
       return( MFopGet(*s,n) );
}
inline MTcell MFsetList( MTcell *s, long n, MTcell v ) {
       return( MFopSet(*s,n,v) );
}

inline MUPbool MFgetSet( MTcell *s, MTcell v ) {
       MTcell  t, assmem = MFop(*s,0);
       if( MAM_in(assmem,v,&t) ) 
           return( _true_ );
       else
           return( _false_ );
}
inline MTcell MFsetSet( MTcell *s, MTcell v ) {
       MSE_insert( *s, MFcopy(v) );
       return( v );
}
inline MUPbool MFinSet( MTcell s, MTcell t ) {
       return( MFgetSet(&s,t) );
}
inline MTcell MFunionSet( MTcell s, MTcell t ) {
       return( MSE_union(s,t) );
}
inline MTcell MFminusSet( MTcell s, MTcell t ) {
       return( MSE_minus(s,t) );
}
inline MTcell MFintersectSet( MTcell s, MTcell t ) {
       return( MSE_intersect(s,t) );
}

inline MTcell MFgetTable( MTcell *s, MTcell idx, long t=MTAC_ARG ) {
       MTcell  tmp;
       if( MTA_read_table(*s,idx,t,&tmp) ) 
           return( tmp );
       else
           return( MCnull );
}
inline MTcell MFsetTable( MTcell *s, MTcell idx, MTcell v, long t=MTAC_ARG ) {
       MTA_write_table( s, idx, t, v );
       return( v );
}

/***
inline MTcell MFnewFunc      ( 
inline MTcell MFnewNamespace ( 

inline MTcell MFnewPolynom   ( 

MTcell MFseq    ( long n=0, ... )

***/


/******************************************************************************/
/*** Service functions and Creation of special objects ************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFcall                                                        */
/* PARAMETER:   s = Any MuPAD Objects (DOM_...)                               */
/*              n = Number of function arguments                              */
/* FUNKTION:    Call the MuPAD function 's' with the argument given.          */
/******************************************************************************/
#ifndef GRAPHIC
inline MTcell MFcall ( MTcell s, long n  Mva_arglist ) {
       MTcell  res;

       Mva_start( args, n );
       res = MFcall1( s, n, args );
       Mva_end( args );
       return( res );
}
inline MTcell MFcall ( char *cs, long n  Mva_arglist ) {
       MTcell  res;

       Mva_start( args, n );
       res = MFcall1( MFident(cs), n, args );
       Mva_end( args );
       return( res );
}
#endif /*** GRAPHIC ***/
       
/******************************************************************************/
/* NAME:        MFdomtype/MFtype                                              */
/* PARAMETER:   s = Any MuPAD Objects (DOM_...)                               */
/* FUNKTION:    Call the MuPAD function (dom)type with argument 's'.          */
/******************************************************************************/
#ifndef GRAPHIC
inline MTcell MFdomtype ( MTcell s ) {
       return( MFcall("domtype", 1, MFcopy(s)) );
}
inline MTcell MFtype ( MTcell s ) {
       return( MFcall("type", 1, MFcopy(s)) );
}
#endif /*** GRAPHIC ***/

#if defined MD_SYSFUNC // Import functions calls for MuPAD builtin functions
#   include "MKT_msf.h"
#endif

/******************************************************************************/
/* NAME:        MFisOption                                                    */
/* PARAMETER:   s      = Any MuPAD Objects (DOM_...)                          */
/*              option = Number of function arguments                         */
/* FUNKTION:    Check if 's' is the option 'option'.                          */
/******************************************************************************/
inline MUPbool MFisOption ( MTcell s, char *option )
{
    if( !MFisIdent(s) ) 
        return( _false_ );
    else if( strcmp(MFstring(s),option) != 0 )
        return( _false_ );
    else
        return( _true_ );

}

/******************************************************************************/
/*** Compare ******************************************************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFequal                                                       */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Check equality for any kind of MuPAD objects.                 */
/******************************************************************************/
inline MUPbool MFequal ( MTcell s, MTcell t ) {
       return( (MUPbool) MCM_equal(s,t) );
}

/******************************************************************************/
/* NAME:        MFcmp                                                         */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Compare 's' with 't'. Return: -1(less), 0(equal), 1(greater). */
/******************************************************************************/
inline int MFcmp ( MTcell s, MTcell t ) {
       return( (int) MCM_compare_intern(s,t) );
}

/******************************************************************************/
/* NAME:        MFxxx - numerical comparations                                */
/* PARAMETER:   s, t = Any MuPAD Objects (DOM_...)                            */
/* FUNKTION:    Compare numerical data. 's' and 't' must be numbers.          */
/******************************************************************************/
inline MUPbool MFeq   ( MTcell s, MTcell t ) { return( (MUPbool) MCA_eq (s,t) ); }
inline MUPbool MFneq  ( MTcell s, MTcell t ) { return( (MUPbool) MCA_neq(s,t) ); }
inline MUPbool MFlt   ( MTcell s, MTcell t ) { return( (MUPbool) MCA_lt (s,t) ); }
inline MUPbool MFle   ( MTcell s, MTcell t ) { return( (MUPbool) MCA_le (s,t) ); }
inline MUPbool MFgt   ( MTcell s, MTcell t ) { return( (MUPbool) MCA_gt (s,t) ); }
inline MUPbool MFge   ( MTcell s, MTcell t ) { return( (MUPbool) MCA_ge (s,t) ); }

/***

*** string comparations ***

inline int MFcmpString ( MTcell s, char *t ) {
       if( !MFisString(s) ) return( _false_ );
       else 
inline int MFcmpString ( MTcell s, MTcell t ) {
       if( !MFisString(t) ) 
       else MFcmpString( s, MFstring(t) );
}

inline MTcell MFcmpIdent  ( MTcell s, MTcell t )
inline MTcell MFcmpIdent  ( MTcell s, char *t )

***/

/******************************************************************************/
/*** Arithmetic ***************************************************************/
/******************************************************************************/

/***
inline MTcell MFpari1 ( MTcell s, GEN (*pf)(ANY_ARGS) ) 
{
    GEN  g = MCA_set_prec(MCA_cat_to_pari(s));    
    
    return( 
         MCA_new_cat_pari( MCstorage, 
             (GEN) (*(PARI_FUNC1*)pf)(g, MCAV_DIGITS) )
          );
}

inline MTcell MFlog ( MTcell s ) 
{ 
    return( MFpari1(s,glog) );
}
***/

inline MTcell MFadd   ( MTcell s, MTcell t ) { return(MCA_calc  (s,t,MCAC_PLUS )); }
inline MTcell MFaddto ( MTcell s, MTcell t ) { return(MCA_calc_1(s,t,MCAC_PLUS )); }
inline MTcell MFdiv   ( MTcell s, MTcell t ) { return(MCA_calc  (s,t,MCAC_DIV  )); }
inline MTcell MFmult  ( MTcell s, MTcell t ) { return(MCA_calc  (s,t,MCAC_MULT )); }
inline MTcell MFmultto( MTcell s, MTcell t ) { return(MCA_calc_1(s,t,MCAC_MULT )); }
inline MTcell MFsub   ( MTcell s, MTcell t ) { return(MCA_calc  (s,t,MCAC_MINUS)); }
inline MTcell MFsubto ( MTcell s, MTcell t ) { return(MCA_calc_1(s,t,MCAC_MINUS)); }

/***
inline MTcell MFaddl   ( MTcell s, long   t )
inline MTcell MFdivInt ( MTcell s, MTcell t )
inline MTcell MFgcd    ( MTcell s, MTcell t )
inline MTcell MFlcm    ( MTcell s, MTcell t )
inline MTcell MFmod    ( MTcell s, MTcell t )
inline MTcell MFpower  ( MTcell s, MTcell t )
inline MTcell MFsub    ( MTcell s, MTcell t )

inline MTcell MFinc ( MTcell s )
inline MTcell MFdec ( MTcell s )

inline MTcell MFneg ( MTcell s )
inline MTcell MFrec ( MTcell s )

inline MTcell MFabs ( MTcell s )

inline MTcell MFisSqr ( MTcell s )

inline MTcell MF_to_float ( MTcell s )
***/

/******************************************************************************/
/*** Input/Output *************************************************************/
/******************************************************************************/

/******************************************************************************/
/* NAME:        MFputs                                                        */
/* PARAMETER:   str = A character string                                      */
/* FUNKTION:    Print a unformatted character string in MuPAD.                */
/******************************************************************************/
inline void MFputs( char *str ) {
       MIO_print_string(str);
       MIO_print_string("\n");
}

/******************************************************************************/
/* NAME:        MFprintf                                                      */
/* PARAMETER:   str = A character string                                      */
/*              ... = Optional list of value (refer to 'printf')              */
/* FUNKTION:    Print a formatted character string in MuPAD.                  */
/******************************************************************************/
inline int MFprintf ( char *format Mva_arglist ) {
       int  res;

       Mva_start( args, format );
       res = MFprintf1( format, args );
       Mva_end( args );
       return( res );
}

/******************************************************************************/
/* NAME:        MFout                                                         */
/* PARAMETER:   s = Any MuPAD object (MTcell)                                 */
/* FUNKTION:    Print a MuPAD object                                          */
/******************************************************************************/
inline void MFout ( MTcell s ) {
       MIO_out(s);
}

/******************************************************************************/
/* NAME:        MFexpr2text                                                   */
/* PARAMETER:   s = Any MuPAD object (MTcell)                                 */
/* FUNKTION:    Convert 's' into a C string.                                  */
/******************************************************************************/
inline char *MFexpr2text ( MTcell s ) {
       MTcell tmp = MIO_expr2text(s);
       char   *cs = MMMmv(&tmp,sizeof(STRSIZE),char,MMMread);
       char   *rs = strdup((const char*)cs);
       MFfree( tmp );
       return( rs );
}
inline char *MFtext( MTcell s ) {
       return( MFexpr2text(s) );
}

/******************************************************************************/
/* NAME:        MFtext2expr                                                   */
/* PARAMETER:   c = MuPAD expression given as a C character string.           */
/* FUNKTION:    Convert 'c' into a MuPAD expression (MTcell)                  */
/******************************************************************************/
inline MTcell MFtext2expr ( char *string, long ShowErrors=1 ) {
       MTcell tmp = MFstring(string);
       MTcell res = MPA_parse_string( MFop(tmp,0), ShowErrors );
       MFfree( tmp ); 
       return( res );
}
inline MTcell MFtext( char *string, long ShowErrors=1 ) {
       return( MFtext2expr(string,ShowErrors) );
}
inline MTcell MF( char *string ) {
       return( MFtext(string,1) );
}

inline MTcell MFexec ( MTcell s ) {
       return( MEV_execute(s) );
}

inline MTcell MFeval( MTcell s ) {
       return( MEV_eval(s,MEVC_ANY,MEVC_EVAL) );
}

#endif /*** __MKT_func__ ***/
